/*******************************************************************************
 Graph Project
 Copyright (C) 2006  denton

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ********************************************************************************
 File: src/Canvas1.java
 Version: 0.1.0  Date: 27.07.2006
 Author: denton
 *******************************************************************************/

package Graph;

import java.lang.System.*;
import javax.microedition.lcdui.*;

public class Canvas1 extends Canvas {
    
    static int width;
    static int height;
    static Image screen;
    static String funct = "x";
    static byte scale = 8;
    static boolean turned = false;
    static boolean drew = false;
    static boolean bigfont = false;
    static int xshift = 0;
    static int yshift = 0;
        
    public static int mscale() {
        int x = 1, sl = scale;
        while (sl!=1) {sl/=2; x++;}
        return x;
    }

    private void drawgrid(Graphics g) {
        if (scale>1) {
            g.setColor(64,108,64);
            for (int x=width/2;x>-width*(scale+1)/2;x-=scale) {
                if (turned) g.drawLine(x,height/2+yshift+1,x,height/2+yshift+1); else
                    g.drawLine(x,height/2+yshift-1,x,height/2+yshift-1);
            }
            for (int x=width/2;x<width*(scale+1)/2;x+=scale) {
                if (turned) g.drawLine(x,height/2+yshift+1,x,height/2+yshift+1); else
                    g.drawLine(x,height/2+yshift-1,x,height/2+yshift-1);
            }
            for (int y=height/2;y>-height*(scale+1);y-=scale) {
                g.drawLine(width/2+xshift+1,y,width/2+xshift+1,y);
            }
            for (int y=height/2;y<height*(scale+1);y+=scale) {
                g.drawLine(width/2+xshift+1,y,width/2+xshift+1,y);
            }
        }
    }
    
    private void drawaxis(Graphics g) {
        g.setColor(255,0,0);
        if (turned) {
            g.drawLine(width-2,height/2+2,width-4,height/2+2);
            g.drawLine(width-4,height/2+2,width-4,height/2+4);
            g.drawLine(width-2,height/2+4,width-6,height/2+4);
            g.drawLine(width-6,height/2+4,width-6,height/2+2);
            g.drawLine(width/2-2,height-2,width/2-4,height-4);
            g.drawLine(width/2-2,height-4,width/2-4,height-2);
        } else {
            g.drawLine(width-4,height/2+2+yshift,width-2,height/2+4+yshift);
            g.drawLine(width-2,height/2+2+yshift,width-4,height/2+4+yshift);
            g.drawLine(width/2+2+xshift,1,width/2+2+xshift,3);
            g.drawLine(width/2+2+xshift,3,width/2+4+xshift,3);
            g.drawLine(width/2+4+xshift,1,width/2+4+xshift,5);
            g.drawLine(width/2+2+xshift,5,width/2+4+xshift,5);
        }
            
        g.setColor(0,0,0);
        g.drawLine(width/2+xshift,0,width/2+xshift,height);
        g.drawLine(0,height/2+yshift,width,height/2+yshift);
    }
    
    private void drawfunct(Graphics g) throws GraphException {
        String Funct = funct;
        
        String f;
        Float y;
        
        long ax = 0,ay = 0,lx = 0,ly = 0;
        boolean lw = false;

        Float dscale = new Float(scale);
        Float _dscale = Float.ONE.Div(dscale);
        
        Float dw = new Float(width);
        dw = dw.Div(new Float(2));
        Float dh = new Float(height);
        dh = dh.Div(new Float(2));

        Float tempf = new Float(xshift);
        tempf = tempf.Div(new Float(scale));

        Float lbound = dw.Div(new Float(-scale)).Sub(tempf);

        Float rbound = dw.Div(new Float(scale)).Sub(tempf);

        Funct = Parser.replaceConstants(Funct);
        Funct = Parser.replaceBrackets(Funct);
        g.setColor(0,128,192);

        try {Parser.checkSyntax(Funct);} catch (GraphException e) {throw (new GraphException(Parser.e_InvalidExpression));}
        
        for (Float x=lbound;x.Less(rbound);x=x.Add(_dscale)) {
            f = Funct;
            if (f.indexOf("x")>=0) f = Parser.replacestr(f,"x","("+x.toString()+")");
            if (f.indexOf("х")>=0) f = Parser.replacestr(f,"х","("+x.toString()+")");

            try {
                y = Parser.calculate(f);
                Float dx = Float.ZERO;
                Float dy = Float.ZERO;
                if (turned) {
                    dx = y.Mul(dscale).Add(dw);
                    dy = x.Mul(dscale).Add(dh);
                } else {
                    dx = x.Mul(dscale).Add(dw);
                    dy = y.Mul(dscale).Neg().Add(dh);
                }
                ax = dx.toLong()+xshift;
                ay = dy.toLong()+yshift;

                if (ay<-10) ay = -10;
                if (ay>height+10) ay = height+10;

                g.drawLine((int)ax,(int)ay,(int)ax,(int)ay);
                if ((lw)&(( (ax>=0)&(ay>=0)&(ax<=height)&(ay<=width) )|( (lx>=0)&(ly>=0)&(lx<=height)&(ly<=width) )))
                   g.drawLine((int)ax,(int)ay,(int)lx,(int)ly);
                lw = true;
            } catch (GraphException e) {lw = false;}

            lx = ax;
            ly = ay;
        }
        g.setColor(0,127,0);
        g.drawString(funct,0,0,Graphics.LEFT|Graphics.TOP);
    }

    public void paint(Graphics g) {
        if (!drew) {
            screen = javax.microedition.lcdui.Image.createImage(width,height);
            Graphics gc = screen.getGraphics();
            gc.setColor(255,255,255);
            gc.fillRect(0,0,width,height);
            if (bigfont) gc.setFont(Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_MEDIUM));
                else gc.setFont(Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL));

            long t1 = java.lang.System.currentTimeMillis();
            this.drawgrid(gc);
            this.drawaxis(gc);
            try {this.drawfunct(gc);} catch (GraphException e) {
                Alert a = new Alert(Lang.S[Graph.lng][17],e.getMessage(),null,null);
                a.setTimeout(Alert.FOREVER);
                Graph.display.setCurrent(a);
            }
            this.drawaxis(gc);
            long t2 = java.lang.System.currentTimeMillis();
            String time = String.valueOf(t2-t1);
            if (time.length()<=3) {
                if (time.length()==1) time = "0"+time;
                if (time.length()==2) time = "0"+time;
                time = "0."+time;
            } else time = Parser.insert(".",time,time.length()-3);
            gc.setColor(0,127,0);
            gc.drawString(time+" s",0,height,Graphics.LEFT|Graphics.BOTTOM);
            
            drew = true;
        }
        g.drawImage(screen,0,0,0);
    }
   
    /**
     * Called when a key is pressed.
     */
    protected  void keyPressed(int keyCode) {
        if (!turned) {
            if ((keyCode==KEY_NUM1)&(height/2-yshift>2*scale)&(width/2-xshift>2*scale)) {xshift+=scale; yshift+=scale; drew = false; repaint();}
            if ((keyCode==KEY_NUM2)&(height/2-yshift>2*scale)) {yshift+=scale; drew = false; repaint();}
            if ((keyCode==KEY_NUM3)&(height/2-yshift>2*scale)&(width/2+xshift>scale)) {xshift-=scale; yshift+=scale; drew = false; repaint();}
            if ((keyCode==KEY_NUM4)&(width/2-xshift>2*scale)) {xshift+=scale; drew = false; repaint();}
            if ((keyCode==KEY_NUM6)&(width/2+xshift>scale)) {xshift-=scale; drew = false; repaint();}
            if ((keyCode==KEY_NUM7)&(width/2-xshift>2*scale)&(height/2+yshift>scale)) {yshift-=scale; xshift+=scale; drew = false; repaint();}
            if ((keyCode==KEY_NUM8)&(height/2+yshift>scale)) {yshift-=scale; drew = false; repaint();}
            if ((keyCode==KEY_NUM9)&(width/2+xshift>scale)&(height/2+yshift>scale)) {xshift-=scale; yshift-=scale; drew = false; repaint();}
        }
        if ((keyCode==KEY_NUM5)&((xshift!=0)|(yshift!=0))) {xshift = yshift = 0; drew = false; repaint();}
    }
    
    /**
     * Called when a key is released.
     */
    protected  void keyReleased(int keyCode) {
    }
    
    /**
     * Called when a key is repeated (held down).
     */
    protected  void keyRepeated(int keyCode) {
        keyPressed(keyCode);
    }
    
    /**
     * Called when the pointer is dragged.
     */
    protected  void pointerDragged(int x, int y) {
    }
    
    /**
     * Called when the pointer is pressed.
     */
    protected  void pointerPressed(int x, int y) {
    }
    
    /**
     * Called when the pointer is released.
     */
    protected  void pointerReleased(int x, int y) {
    }
}
